* PACKAGE UCDIFF    !" ʬη׻
*
*"  [HIS] 95/08/14 (takepiro) ̥롼ڤ, ץå
***********************************************************************
      SUBROUTINE ARAJAC               !" ARAKAWA 䥳ӥη׻
     O           ( AJAC ,
     I             PSI  , G   ,
     C             DX   , DZ  ,
     I             ISX  , IFX , ISZ , IFZ ,
     D             NX   , NZ    )
*
*"      << ARAKAWA schemeѤƥ䥳ӥ 
*"           J(PSI,G) = dp/dx dg/dz - dp/dz dg/dx ׻ >>
* [OUTPUT]
      REAL AJAC( NX, NZ )       !" J(PSI,G)
*
* [INPUT]
      REAL PSI ( NX, NZ )       !" ήؿ
      REAL G   ( NX, NZ )       !" ʪ̤2
*
      REAL DX                   !" Xγʻֳ
      REAL DZ                   !" Zγʻֳ
*
      INTEGER ISX               !" X ˥䥳ӥ׻Ϥ
      INTEGER IFX               !" X ˥䥳ӥ׻
      INTEGER ISZ               !" Z ˥䥳ӥ׻Ϥ
      INTEGER IFZ               !" Z ˥䥳ӥ׻
*
      INTEGER NX                !" X μ
      INTEGER NZ                !" Z μ
*
* [INTERNAL WORK]
      REAL RJPP
      REAL RJMP
      REAL RJPM
*
      INTEGER IX
      INTEGER IZ
*
      DO 1020 IZ = ISZ, IFZ
         DO 1010 IX =  ISX, IFX
          RJPP =     ( PSI(IX+1,IZ)-PSI(IX-1,IZ) )/(2.0D0*DX)
     &               * ( G(IX,IZ+1)-G(IX,IZ-1) )/(2.0D0*DZ)
     &           -   ( PSI(IX,IZ+1)-PSI(IX,IZ-1) )/(2.0D0*DZ)
     &             * ( G(IX+1,IZ)-G(IX-1,IZ) )/(2.0D0*DX)
          RJMP =     (   G(IX,IZ+1)*( PSI(IX+1,IZ+1)-PSI(IX-1,IZ+1) )
     &                 - G(IX,IZ-1)*( PSI(IX+1,IZ-1)-PSI(IX-1,IZ-1) ))
     &             / (4.0D0*DX*DZ)
     &           -   (   G(IX+1,IZ)*( PSI(IX+1,IZ+1)-PSI(IX+1,IZ-1) )
     &                 - G(IX-1,IZ)*( PSI(IX-1,IZ+1)-PSI(IX-1,IZ-1) ))
     &             / (4.0D0*DX*DZ)
          RJPM =     (   PSI(IX+1,IZ)*( G(IX+1,IZ+1)-G(IX+1,IZ-1) )
     &                 - PSI(IX-1,IZ)*( G(IX-1,IZ+1)-G(IX-1,IZ-1) ))
     &             / (4.0D0*DX*DZ)
     &           -   (   PSI(IX,IZ+1)*( G(IX+1,IZ+1)-G(IX-1,IZ+1) )
     &                 - PSI(IX,IZ-1)*( G(IX+1,IZ-1)-G(IX-1,IZ-1) ))
     &             / (4.0D0*DX*DZ)
          AJAC( IX,IZ ) = ( RJPP + RJMP + RJPM )/3.0D0
 1010   CONTINUE
 1020 CONTINUE
*
      RETURN
      END
***********************************************************************
      SUBROUTINE CLAPLA             !" ץ饷κʬ׻Ԥ
     O           ( ALAP,
     I             F   ,
     C             DX  , DZ  , 
     I             ISX , IFX , ISZ , IFZ ,
     D             NX  , NZ    )
*
* [OUTPUT]
      REAL    ALAP( NX, NZ  )   !" ʪ̤Υץ饷
*
* [INPUT]
      REAL    F( NX, NZ )       !" ʪ̤2
*
      REAL    DX                !" X γʻֳ
      REAL    DZ                !" Z γʻֳ
*
      INTEGER ISX               !" X ˥ץ饷׻Ϥ
      INTEGER IFX               !" X ˥ץ饷׻
      INTEGER ISZ               !" Z ˥ץ饷׻Ϥ
      INTEGER IFZ               !" Z ˥ץ饷׻
*
      INTEGER NX                !" X μ
      INTEGER NZ                !" Z μ
*
* [INTERNAL WORK]
      INTEGER IX                !" 롼ץ
      INTEGER IZ                !" 롼ץ
*
*"        < 1. ץ饷η׻ >
*
      DO 1020 IZ = ISZ, IFZ
        DO 1010 IX = ISX, IFX
          ALAP(IX,IZ) =     ( F(IX-1,IZ)-2.0D0*F(IX,IZ)+F(IX+1,IZ) )
     &                    / DX**2
     &                  +   ( F(IX,IZ-1)-2.0D0*F(IX,IZ)+F(IX,IZ+1) )
     &                    / DZ**2
 1010   CONTINUE
 1020 CONTINUE
*
      RETURN
      END
